<?php
/**
* SP FRAMEWORK FILE - DO NOT EDIT!
* 
* AJAX Functions
******************************************************************/

/**
* load ajax listener to WP
*
******************************************************************/
if (is_admin()) :
	add_action('wp_ajax_nopriv_sp_theme_save', 'sp_theme_save');
	add_action('wp_ajax_sp_theme_save', 'sp_theme_save');
	add_action('wp_ajax_nopriv_sp_theme_upload', 'sp_theme_upload');
	add_action('wp_ajax_sp_theme_upload', 'sp_theme_upload');
	add_action('wp_ajax_nopriv_sp_delete_image', 'sp_delete_image');
	add_action('wp_ajax_sp_delete_image', 'sp_delete_image');
	add_action('wp_ajax_nopriv_sp_theme_reset', 'sp_theme_reset');
	add_action('wp_ajax_sp_theme_reset', 'sp_theme_reset');
	add_action('wp_ajax_nopriv_sp_clear_cache_ajax', 'sp_clear_cache_ajax');
	add_action('wp_ajax_sp_clear_cache_ajax', 'sp_clear_cache_ajax');
	add_action('wp_ajax_nopriv_sp_clear_star_ratings_ajax', 'sp_clear_star_ratings_ajax');
	add_action('wp_ajax_sp_clear_star_ratings_ajax', 'sp_clear_star_ratings_ajax');

endif;

/**
* save data function
*
******************************************************************/
function sp_theme_save() {
	$nonce = $_POST['ajax_custom_nonce'];
	if ( !wp_verify_nonce($nonce, 'ajax_custom_nonce')) {
	     die ('errors');
	}
	$form_data = $_POST['form_items'];
	$form_data = str_replace('&','####-####',$form_data);
	$form_data = urldecode($form_data);
	$arr = array();
	foreach (explode('####-####', $form_data) as $part) {
    	list($key, $value) = explode('=', $part, 2);
		if ($key == 'action' && $value == 'save' || $key == '_wpnonce' || $key == '_wp_http_referer') {
        	continue;
    	}
		$arr[$key] = $value;
	}
	save_data($arr);
		echo 'done';	
	exit;	
	
}

/**
* delete image
*
******************************************************************/
function sp_delete_image() {
	$upload_dir = wp_upload_dir();
	$nonce = $_POST['ajax_custom_nonce'];
	if ( !wp_verify_nonce($nonce, 'ajax_custom_nonce')) {
	     die ('false');
	}
	if(is_writable($upload_dir['basedir'].'/sp-uploads/'.$_POST['image'])) {
		if (@unlink($upload_dir['basedir'].'/sp-uploads/'.$_POST['image'])) {
			echo "true";
		} else {
			echo "false";	
		}
	} else {
		echo "false";	
	}
	exit;
}

/**
* upload image
*
******************************************************************/
function sp_theme_upload(){
	//$nonce = $_POST['ajax_custom_nonce'];
	//if ( !wp_verify_nonce($nonce, 'ajax_custom_nonce')) {
	//     die ('errors');
	//}	
	$upload_dir = wp_upload_dir();
	if(!empty($_FILES)) {
		if(!isset($_POST['target']) || $_POST['target'] == ''){
			$target = $upload_dir['basedir'].'/sp-uploads';
		} else {
			$target = $upload_dir['basedir'].'/sp-uploads'.$_POST['target'];
		}	
		$target = rtrim($target, "/");
		
		$check = false;
		if(!is_dir($target)){		
			if(!mkdir($target, 0777, true)){
				echo "errors";	
			} else {
				$check = true; 	
			}
		} else {
			$check = true;	
		}
		if($check){
			if(move_uploaded_file($_FILES['Filedata']['tmp_name'], $target."/".str_replace(" ", "-", basename($_FILES['Filedata']['name'])))){
				if (isset($_POST['id'])) {
					echo $_POST['id'];
				} else {
					echo "done";	
				}
			} else {
				echo "errors";
			}
		}
	}
	exit;
}

/**
* get the WP upload directory
*
******************************************************************/
function get_upload_dir($dir) {
  $uploadpath = wp_upload_dir();
  if ($uploadpath['baseurl']=='') $uploadpath['baseurl'] = get_bloginfo('siteurl').'/wp-content/uploads';
  return $uploadpath[$dir];
}

/**
* check if site has ssl enabled
*
******************************************************************/
function check_ssl() {
	if (is_ssl()) :
		echo "https://";
	else :
		echo "http://";
	endif;	
}

/**
* restore default settings
*
******************************************************************/
function sp_theme_reset() {
	global $config, $wpdb;
	
	$data = array();
	if (is_array($config['tab'])) {
		foreach ($config['tab'] as $tabs) {
			foreach ($tabs['panel'] as $panels) {
				if (is_array($panels['wrapper'])) {
					foreach ($panels['wrapper'] as $wrappers) {
						if (is_array($wrappers['module'])) {
							foreach ($wrappers['module'] as $module) {
								$data[THEME_SHORTNAME.$module['_attr']['id']] = $module['_attr']['std'];
							}
						}
					}
				}
			}			
		}
		
	}
	$results = save_data($data);
	if ($results) {
	  update_option('single_view_image_height',sp_themeInit('wpec_single_view_image_size','height'));
	  update_option('single_view_image_width',sp_themeInit('wpec_single_view_image_size','width'));
	  update_option('product_image_height',sp_themeInit('wpec_product_image_size','height'));
	  update_option('product_image_width',sp_themeInit('wpec_product_image_size','width'));
	  update_option('wpsc_crop_thumbnails',sp_themeInit('wpec_image_crop','crop'));
	  
	  // set the default product gallery thumbnail size
	  update_option('wpsc_gallery_image_height',sp_themeInit('wpec_product_gallery_size','height'));
	  update_option('wpsc_gallery_image_width',sp_themeInit('wpec_product_gallery_size','width'));
	  
	  // set the default product group thumbnail size
	  update_option('category_image_height',sp_themeInit('wpec_product_category_size','height'));
	  update_option('category_image_width',sp_themeInit('wpec_product_category_size','width'));
	  
	  // set the default post thumbnail size
	  update_option('thumbnail_size_w',sp_themeInit('set_post_thumbnail_size','width'));
	  update_option('thumbnail_size_h',sp_themeInit('set_post_thumbnail_size','height'));
	  update_option('thumbnail_crop',sp_themeInit('set_post_thumbnail_size','crop'));
	  
	  // set the default WPEC pagination settings
	  update_option('use_pagination',sp_themeInit('wpec_pagination','enable'));
	  update_option('wpsc_products_per_page',sp_themeInit('wpec_pagination','per_page'));
	  update_option('wpsc_page_number_position',sp_themeInit('wpec_pagination','position'));
				  
	  // turn on add to cart for grid view
	  update_option("display_addtocart",sp_themeInit('wpec_gridview_addtocart','enable'));
		echo "done";
	} else {
		echo "errors";	
	}
	exit;
}

/**
* empty timthumb cache folder
*
******************************************************************/
function sp_clear_cache_ajax() {
	$nonce = $_POST['ajax_custom_nonce'];
	if ( !wp_verify_nonce($nonce, 'ajax_custom_nonce')) {
	     //die ('errors');
	}
    $path = TEMPLATEPATH.'/sp-framework/timthumb/cache/';
 	if ($handle = opendir($path)) {
          while (false !== ($file = readdir($handle))) {
               if ($file != "." && $file != "..") {
               		// If it's a file, delete it
               		if(is_file($path."/".$file)) {
 
                    	if(unlink($path."/".$file)) {
                    		$output = 'done';     
                    	}
               		} else {
 
                    	// It's a directory...
                    	// crawl through the directory and delete the contents               
                    	if($handle2 = opendir($path."/".$file)) {
                        	while (false !== ($file2 = readdir($handle2))) {
                              if ($file2 != "." && $file2 != "..") {
                                   if(unlink($path."/".$file."/".$file2)) {
                                   $output = 'done';    
                                   }
                              }
                         	}
                    	}
                    	if(rmdir($path."/".$file)) {
                    		$output = 'done';     
                    	}
               		}
               }
          }
		 closedir($path);
		 $output = 'done';
     } else {
		$output = 'errors'; 
	 } 
    
	echo $output;
    exit;
}

/**
* empty all product star ratings
*
******************************************************************/

function sp_clear_star_ratings_ajax() {
	global $wpdb;
	
	$nonce = $_POST['ajax_custom_nonce'];
	if ( !wp_verify_nonce($nonce, 'ajax_custom_nonce')) {
	     //die ('errors');
	}
	
	$sql = "TRUNCATE TABLE `wp_wpsc_product_rating`";
	if ($wpdb->query($sql)) {
		echo 'done';	
	} else {
		echo 'errors';	
	}
	exit;
	
}
?>