<?php 
/*-----------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------
PLEASE DO NOT CHANGE ANYTHING IN THIS FILE.

Theme Name: SP Organico Theme
Theme URI: http://splashingpixels.com
Description: An "green", organic style style e-commerce theme.
Author: Splashing Pixels Team
Version: 1.0
Tags: light-green,sage,organic,clean,2-column,e-commerce,fixed-width,960
-------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------*/


// enable threaded comments
function enable_threaded_comments(){
	if (!is_admin()) {
		if (is_singular() AND comments_open() AND (get_option('thread_comments') == 1))
			wp_enqueue_script('comment-reply');
		}
	}
add_action('get_header', 'enable_threaded_comments');

// sets the length of the post excerpts
if (!function_exists('sp_excerpt_length')) {
	function sp_excerpt_length($length) {
		return 40;
	}
	add_filter('excerpt_length', 'sp_excerpt_length');
}

// sets the continue reading more link
if (!function_exists('sp_continue_reading_link')) {
	function sp_continue_reading_link() {
		return ' <a href="'. get_permalink() . '">' . __( 'Read More &gt;', 'sp' ) . '</a>';
	}
}

// custom excerpt length
function sp_excerpt($excerpt = '', $excerpt_length = 40, $readmore = "Read More &gt;",$tags = '<a>') {
	global $post;
	$string_check = explode(' ', $excerpt);
	
	if (count($string_check, COUNT_RECURSIVE) > $excerpt_length) :
	$new_excerpt_words = explode(' ', $excerpt, $excerpt_length+1);
	array_pop($new_excerpt_words);
	$excerpt_text = implode(' ', $new_excerpt_words);
	$temp_content = strip_tags($excerpt_text, $tags);
	$short_content = preg_replace('`\[[^\]]*\]`','',$temp_content);
	$short_content .= ' ... <br /><a href="'.$post->guid .'" title="'.$post->post_title.'">'.$readmore.'</a>';
	endif;
	return $short_content;
}

if (!function_exists('sp_auto_excerpt_more')) {
	function sp_auto_excerpt_more( $more ) {
		return ' &hellip;' . sp_continue_reading_link();
	}
	add_filter( 'excerpt_more', 'sp_auto_excerpt_more' );
}

// shortens the previous and next post titles
// shortens the previous and next post titles
if (!function_exists('sp_shorten_title_post_link')) {
	function sp_shorten_title_post_link($linkstring,$link) {
		$characters = 25;
		preg_match('/<a.*?>(.*?)<\/a>/is',$linkstring,$matches);
		$displayedTitle = preg_replace('/<span.*<\/span>/is','',$matches[1]);
		$newTitle = sp_shorten_with_ellipsis($displayedTitle,$characters);
		return str_replace('>'.$displayedTitle.'<','>'.$newTitle.'<',$linkstring);
	}
	add_filter('previous_post_link','sp_shorten_title_post_link',10,2);
	add_filter('next_post_link','sp_shorten_title_post_link',10,2);	
}

if (!function_exists('sp_shorten_with_ellipsis')) {
	function sp_shorten_with_ellipsis($inputstring,$characters) {
	  return (strlen($inputstring) >= $characters) ? substr($inputstring,0,($characters-3)) . '...' : $inputstring;
	}
}


if (!function_exists('sp_comment')) :

// function to manipulate the comments/pingbacks
function sp_comment($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment;
	switch ($comment->comment_type) :
		case '' :
	?>
	<li <?php comment_class('group'); ?> id="li-comment-<?php comment_ID(); ?>">
		<div id="comment-<?php comment_ID(); ?>" class="comment_container group">
		<div class="comment-author vcard">
			<?php echo get_avatar($comment, 80); ?>
			<?php printf( __('%s', 'sp'), sprintf('<cite class="fn">%s</cite>', get_comment_author_link())); ?>
            <div class="comment-meta commentmetadata">
                <?php
                    /* translators: 1: date, 2: time */
                    printf( __('%1$s <br /> %2$s', 'sp'), get_comment_date(), get_comment_time()); ?><?php edit_comment_link( __('(Edit)', 'sp'), ' ' );
                ?>
            </div><!-- .comment-meta .commentmetadata -->
		</div><!-- .comment-author .vcard -->
		<div class="comment_wrap group">
            <div class="comment-body">
			<?php if ($comment->comment_approved == '0') : ?>
                <em class="comment_wait"><?php _e('Your comment is awaiting moderation.', 'sp'); ?></em>
            <?php endif; ?>
			
			<?php comment_text(); ?></div>
    
            <div class="reply">
                <?php comment_reply_link( array_merge( $args, array( 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
            </div><!-- .reply -->
        </div><!--close comment_wrap-->
	</div><!-- #comment-##  -->

	<?php
			break;
		case 'pingback'  :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:', 'sp' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __('(Edit)', 'sp'), ' ' ); ?></p>
	<?php
			break;
	endswitch;
} //end sp_comment function
endif;


// removes the default recent comments style
function sp_remove_recent_comments_style() {
	global $wp_widget_factory;
	remove_action( 'wp_head', array( $wp_widget_factory->widgets['WP_Widget_Recent_Comments'], 'recent_comments_style' ) );
}
add_action( 'widgets_init', 'sp_remove_recent_comments_style' );

if ( ! function_exists( 'sp_posted_on' ) ) :
// function to manipulate the posted_on HTML
function sp_posted_on() {
	printf( __( '<span class="calendar-icon">&nbsp;</span>%1$s <span class="meta-sep">by</span> %2$s', 'sp' ),
		sprintf( '<a href="%1$s" title="%2$s" rel="bookmark"><time pubdate datetime="%2$s" class="entry-date">%3$s</time></a>',
			get_permalink(),
			get_the_date('c'),
			get_the_date()
		),
		sprintf( '<span class="author vcard"><a class="url fn n" href="%1$s" title="%2$s">%3$s</a></span>',
			get_author_posts_url( get_the_author_meta( 'ID' ) ),
			sprintf( esc_attr__( 'View all posts by %s', 'sp' ), get_the_author() ),
			get_the_author()
		)
	);
}
endif;

if ( ! function_exists( 'sp_posted_in' ) ) :
// function to manipulate the posted_in HTML
function sp_posted_in() {
	// Retrieves tag list of current post, separated by commas.
	$tag_list = get_the_tag_list( '', ', ' );
	if ( $tag_list ) {
		$posted_in = __( '<span class="article-icon">&nbsp;</span>Posted in %1$s <span class="tag-icon">&nbsp;</span>Tags %2$s. <span class="bookmark-icon">&nbsp;</span>Bookmark the <a href="%3$s" title="Permalink to %4$s" rel="bookmark">permalink</a>', 'sp' );
	} elseif ( is_object_in_taxonomy( get_post_type(), 'category' ) ) {
		$posted_in = __( '<span class="article-icon">&nbsp;</span>Posted in %1$s. <span class="bookmark-icon">&nbsp;</span>Bookmark the <a href="%3$s" title="Permalink to %4$s" rel="bookmark">permalink</a>', 'sp' );
	} else {
		$posted_in = __( '<span class="bookmark-icon">&nbsp;</span>Bookmark the <a href="%3$s" title="Permalink to %4$s" rel="bookmark">permalink</a>', 'sp' );
	}
	// Prints the string, replacing the placeholders.
	printf(
		$posted_in,
		get_the_category_list( ', ' ),
		$tag_list,
		get_permalink(),
		the_title_attribute( 'echo=0' )
	);
}
endif;

if (!function_exists('sp_related_post')) :
function sp_related_post() {
	global $post, $data;
	$blog_related_crop = $data[THEME_SHORTNAME.'blog_related_crop'];
	$blog_related_zoomcrop = $data[THEME_SHORTNAME.'blog_related_zoomcrop'];
	$blog_related_compression = $data[THEME_SHORTNAME.'blog_related_compression'];
	$image_width = sp_themeInit('post_related_image_size','width'); 
	$image_height = sp_themeInit('post_related_image_size','height');
	
	$tags = wp_get_post_tags($post->ID);
	$tagIDs = array();
	if ($tags) {
		$tagcount = count($tags);
    	for ($i = 0; $i < $tagcount; $i++) {
      	$tagIDs[$i] = $tags[$i]->term_id;
    	}		
		$args = array(
			'tag__in' => $tagIDs,
			'post__not_in' => array($post->ID),
			'showposts' => 4,
			'caller_get_posts' => 1
		);
		$my_query = new WP_Query($args);
		if( $my_query->have_posts() ) {
			if (isset($data[THEME_SHORTNAME.'related_post_text']) && $data[THEME_SHORTNAME.'related_post_text'] != '') {
				$custom_text  = $data[THEME_SHORTNAME.'related_post_text'];
			} else {
				$custom_text = 'Related Posts';	
			}
			echo '<div class="related-post group"><h2>'.$custom_text.'</h2><ul>';
			while ($my_query->have_posts()) {
				$post_image_url = wp_get_attachment_image_src( get_post_thumbnail_id(), 'full');
				$my_query->the_post();
			?>
				<li><div class="wrap"><a href="<?php the_permalink() ?>" rel="bookmark" title="Permanent Link to <?php the_title_attribute(); ?>" class="post-image-link"><img width="<?php echo $image_width; ?>" height="<?php echo $image_height; ?>" class="wp-post-image" alt="<?php echo the_title(); ?>" src="<?php echo bloginfo('template_url');?>/sp-framework/timthumb/timthumb.php?src=<?php echo $post_image_url[0]; ?>&amp;h=<?php echo $image_height; ?>&amp;w=<?php echo $image_width; ?>&amp;zc=<?php echo $blog_related_zoomcrop; ?>&amp;q=<?php echo $blog_related_compression; ?>&amp;a=<?php echo $blog_related_crop; ?>" /><span class="more"><?php _e('Read More','sp'); ?></span></a></div><h3><a href="<?php the_permalink() ?>" rel="bookmark" title="Permanent Link to <?php the_title_attribute(); ?>" class="post-image-link"><?php the_title(); ?></a></h3></li>
			<?php
			}
			echo '</ul></div>';
			wp_reset_query();
		}
	}
}
endif;

?>